#include "Car_DB1.h"

Car_DB::Car_DB () 
{ 
	_ptrHead = NULL; 
}

bool Car_DB::addCar (Car *ptrNewCar)
{
	// now allocate a new listcar_element
	CarNode *ptrNewElement = new CarNode();
	if( ptrNewElement == NULL )
		return false;

	// put the car pointer into "data" and hook up the pointers
	ptrNewElement->ptrCar	= ptrNewCar;
	ptrNewElement->ptrNext	= _ptrHead;
	_ptrHead = ptrNewElement;
  
	return true;

}

bool Car_DB::deleteCar (string strSerial)
{
	bool	bFound;  
	CarNode	*ptrCurrent	= NULL, 
			*ptrPrev	= NULL;  
	Car		*ptrCurrentCar;

	// start at the beginning
	bFound		= false;
	ptrCurrent	=_ptrHead;
	while(!bFound && ptrCurrent != NULL)
	{
		ptrCurrentCar = ptrCurrent->ptrCar;
		if(ptrCurrentCar->getSerial() == strSerial) 
			bFound = true;
		else 
		{
			ptrPrev		= ptrCurrent;
			ptrCurrent	= ptrCurrent->ptrNext;
		}
	}
	
	if(bFound)// then we need to delete the element at temp
	{
      if (ptrPrev == NULL)  // this is the first one!!
		_ptrHead = _ptrHead->ptrNext;
      else
		ptrPrev->ptrNext = ptrCurrent->ptrNext;
      
	  delete ptrCurrent;
      return true;
	}
	else 
	{
		cout << "Car does not exist -- serial: " << strSerial << endl;
		return false;
	}
}

void Car_DB::displayCar(string serial)
{
	// Can you write code to find the car whose serial is passed and call display on that car ?
}

void Car_DB::displayAll()
{
	CarNode *ptrCurrentNode = _ptrHead;
	Car		*ptrCurrentCar  = NULL;

	while(ptrCurrentNode != NULL)
    {
      ptrCurrentCar = ptrCurrentNode->ptrCar; // get access to car in current node
	  ptrCurrentCar->display();   
      ptrCurrentNode = ptrCurrentNode->ptrNext;  // move to next Node
    }
}

