#include "Car_DB1.h"

int main()
{
	Car_DB dealership;
	
	Car *ptrCar = new Car ("AB12345678", 25000);
	ptrCar->setManufacturer("Ford");
	ptrCar->setModel("Escort");
	ptrCar->setSeats(5);
	
	dealership.addCar(ptrCar);
	
	cout << "After 1st addition..." << endl;
	dealership.displayAll();
	cout << endl;

	ptrCar = new Car ("CD67654321", 35000);
	ptrCar->setManufacturer("Toyota");
	ptrCar->setModel("Camry");
	ptrCar->setSeats(5);
	dealership.addCar(ptrCar);
	cout << "After 2nd addition..." << endl;
	dealership.displayAll();
	cout << endl;

	ptrCar = new Car ("TR12345678", 65000);
	ptrCar->setManufacturer("Daimler");
	ptrCar->setModel("Mercedez Benz");
	ptrCar->setSeats(6);
	dealership.addCar(ptrCar);
	cout << "After 3rd addition..." << endl;
	dealership.displayAll();
	cout << endl;

	ptrCar = new Car ("MN12345678", 20000);
	ptrCar->setManufacturer("Chevy");
	ptrCar->setModel("Cavalier");
	ptrCar->setSeats(4);
	dealership.addCar(ptrCar);
	cout << "After 4th addition..." << endl;
	dealership.displayAll();
	cout << endl;

	cout << "Display just car with Serial: MN12345678" << endl;
	dealership.displayCar("MN12345678");
	cout << endl;

	cout << "Display just car with Serial: BB6789076" << endl;
	dealership.displayCar("BB6789076");
	cout << endl;

	dealership.deleteCar("TR12345678");
	cout << "After deletion of TR12345678 ..." << endl;
	dealership.displayAll();
	cout << endl;

	dealership.deleteCar("MN12345678");
	cout << "After deletion of MN12345678 ..." << endl;
	dealership.displayAll();
	cout << endl;

	return 0;

}

int main2()
{
	Car*	ptrCar;
	Radio*	ptrRadio;

	ptrCar = new Car ("AB12345678", 25000);
	ptrCar->setManufacturer("Ford");
	ptrCar->setModel("Escort");
	ptrCar->setSeats(5);

	ptrRadio = new Radio( );
	ptrCar->addRadio( ptrRadio );
	
	ptrCar->changeChannel( 100.5 );

	ptrCar->turnCarOn( );
	
	ptrCar->gotoLocation( 173, 299 );

	ptrCar->stop( );

	ptrCar->removeRadio( );

	ptrCar->turnCarOff( );

	delete ptrRadio;

	return 0;
}